diff -urN systemd-216/src/libsystemd/sd-bus/bus-control.c systemd-217/src/libsystemd/sd-bus/bus-control.c
--- systemd-216/src/libsystemd/sd-bus/bus-control.c	2014-11-03 09:35:37.159269577 -0800
+++ systemd-217/src/libsystemd/sd-bus/bus-control.c	2014-10-27 10:09:26.606862015 -0700
@@ -169,7 +169,7 @@
         if (r < 0)
                 return -errno;
 
-        return n->flags;
+        return 0;
 }
 
 static int bus_release_name_dbus1(sd_bus *bus, const char *name) {
@@ -243,7 +243,7 @@
 static int kernel_get_list(sd_bus *bus, uint64_t flags, char ***x) {
         struct kdbus_cmd_name_list cmd = {};
         struct kdbus_name_list *name_list;
-        struct kdbus_cmd_name *name;
+        struct kdbus_name_info *name;
         uint64_t previous_id = 0;
         int r;
 
@@ -265,12 +265,14 @@
                 if ((flags & KDBUS_NAME_LIST_UNIQUE) && name->owner_id != previous_id) {
                         char *n;
 
-                        if (asprintf(&n, ":1.%llu", (unsigned long long) name->owner_id) < 0)
-                                return -ENOMEM;
+                        if (asprintf(&n, ":1.%llu", (unsigned long long) name->owner_id) < 0) {
+                                r = -ENOMEM;
+                                goto fail;
+                        }
 
                         r = strv_consume(x, n);
                         if (r < 0)
-                                return r;
+                                goto fail;
 
                         previous_id = name->owner_id;
                 }
@@ -281,16 +283,18 @@
 
                 if (entry_name && service_name_is_valid(entry_name)) {
                         r = strv_extend(x, entry_name);
-                        if (r < 0)
-                                return -ENOMEM;
+                        if (r < 0) {
+                                r = -ENOMEM;
+                                goto fail;
+                        }
                 }
         }
 
-        r = kernel_cmd_free(bus, cmd.offset);
-        if (r < 0)
-                return r;
+        r = 0;
 
-        return 0;
+fail:
+        kernel_cmd_free(bus, cmd.offset);
+        return r;
 }
 
 static int bus_list_names_kernel(sd_bus *bus, char ***acquired, char ***activatable) {
@@ -388,61 +392,16 @@
                 return bus_list_names_dbus1(bus, acquired, activatable);
 }
 
-static int bus_get_owner_kdbus(
-                sd_bus *bus,
-                const char *name,
-                uint64_t mask,
-                sd_bus_creds **creds) {
+static int bus_populate_creds_from_items(sd_bus *bus,
+                                         struct kdbus_info *info,
+                                         uint64_t mask,
+                                         sd_bus_creds *c) {
 
-        _cleanup_bus_creds_unref_ sd_bus_creds *c = NULL;
-        struct kdbus_cmd_conn_info *cmd;
-        struct kdbus_conn_info *conn_info;
         struct kdbus_item *item;
-        size_t size, l;
-        uint64_t m, id;
+        uint64_t m;
         int r;
 
-        r = bus_kernel_parse_unique_name(name, &id);
-        if (r < 0)
-                return r;
-        if (r > 0) {
-                size = offsetof(struct kdbus_cmd_conn_info, items);
-                cmd = alloca0_align(size, 8);
-                cmd->id = id;
-        } else {
-                l = strlen(name) + 1;
-                size = offsetof(struct kdbus_cmd_conn_info, items) + KDBUS_ITEM_SIZE(l);
-                cmd = alloca0_align(size, 8);
-                cmd->items[0].size = KDBUS_ITEM_HEADER_SIZE + l;
-                cmd->items[0].type = KDBUS_ITEM_NAME;
-                memcpy(cmd->items[0].str, name, l);
-        }
-
-        cmd->size = size;
-        kdbus_translate_attach_flags(mask, (uint64_t*) &cmd->flags);
-
-        r = ioctl(bus->input_fd, KDBUS_CMD_CONN_INFO, cmd);
-        if (r < 0)
-                return -errno;
-
-        conn_info = (struct kdbus_conn_info *) ((uint8_t *) bus->kdbus_buffer + cmd->offset);
-
-        /* Non-activated names are considered not available */
-        if (conn_info->flags & KDBUS_HELLO_ACTIVATOR)
-                return name[0] == ':' ? -ENXIO : -ESRCH;
-
-        c = bus_creds_new();
-        if (!c)
-                return -ENOMEM;
-
-        if (mask & SD_BUS_CREDS_UNIQUE_NAME) {
-                if (asprintf(&c->unique_name, ":1.%llu", (unsigned long long) conn_info->id) < 0)
-                        return -ENOMEM;
-
-                c->mask |= SD_BUS_CREDS_UNIQUE_NAME;
-        }
-
-        KDBUS_ITEM_FOREACH(item, conn_info, items) {
+        KDBUS_ITEM_FOREACH(item, info, items) {
 
                 switch (item->type) {
 
@@ -471,10 +430,8 @@
                 case KDBUS_ITEM_PID_COMM:
                         if (mask & SD_BUS_CREDS_COMM) {
                                 c->comm = strdup(item->str);
-                                if (!c->comm) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->comm)
+                                        return -ENOMEM;
 
                                 c->mask |= SD_BUS_CREDS_COMM;
                         }
@@ -483,10 +440,8 @@
                 case KDBUS_ITEM_TID_COMM:
                         if (mask & SD_BUS_CREDS_TID_COMM) {
                                 c->tid_comm = strdup(item->str);
-                                if (!c->tid_comm) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->tid_comm)
+                                        return -ENOMEM;
 
                                 c->mask |= SD_BUS_CREDS_TID_COMM;
                         }
@@ -495,10 +450,8 @@
                 case KDBUS_ITEM_EXE:
                         if (mask & SD_BUS_CREDS_EXE) {
                                 c->exe = strdup(item->str);
-                                if (!c->exe) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->exe)
+                                        return -ENOMEM;
 
                                 c->mask |= SD_BUS_CREDS_EXE;
                         }
@@ -508,10 +461,8 @@
                         if (mask & SD_BUS_CREDS_CMDLINE) {
                                 c->cmdline_size = item->size - KDBUS_ITEM_HEADER_SIZE;
                                 c->cmdline = memdup(item->data, c->cmdline_size);
-                                if (!c->cmdline) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->cmdline)
+                                        return -ENOMEM;
 
                                 c->mask |= SD_BUS_CREDS_CMDLINE;
                         }
@@ -524,20 +475,16 @@
 
                         if (m) {
                                 c->cgroup = strdup(item->str);
-                                if (!c->cgroup) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->cgroup)
+                                        return -ENOMEM;
 
                                 r = bus_get_root_path(bus);
                                 if (r < 0)
-                                        goto fail;
+                                        return r;
 
                                 c->cgroup_root = strdup(bus->cgroup_root);
-                                if (!c->cgroup_root) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->cgroup_root)
+                                        return -ENOMEM;
 
                                 c->mask |= m;
                         }
@@ -548,12 +495,10 @@
                              SD_BUS_CREDS_INHERITABLE_CAPS | SD_BUS_CREDS_BOUNDING_CAPS) & mask;
 
                         if (m) {
-                                c->capability_size = item->size - KDBUS_ITEM_HEADER_SIZE;
-                                c->capability = memdup(item->data, c->capability_size);
-                                if (!c->capability) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                c->capability_size = item->size - offsetof(struct kdbus_item, caps.caps);
+                                c->capability = memdup(item->caps.caps, c->capability_size);
+                                if (!c->capability)
+                                        return -ENOMEM;
 
                                 c->mask |= m;
                         }
@@ -562,10 +507,8 @@
                 case KDBUS_ITEM_SECLABEL:
                         if (mask & SD_BUS_CREDS_SELINUX_CONTEXT) {
                                 c->label = strdup(item->str);
-                                if (!c->label) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->label)
+                                        return -ENOMEM;
 
                                 c->mask |= SD_BUS_CREDS_SELINUX_CONTEXT;
                         }
@@ -585,7 +528,7 @@
                         if ((mask & SD_BUS_CREDS_WELL_KNOWN_NAMES) && service_name_is_valid(item->name.name)) {
                                 r = strv_extend(&c->well_known_names, item->name.name);
                                 if (r < 0)
-                                        goto fail;
+                                        return r;
 
                                 c->mask |= SD_BUS_CREDS_WELL_KNOWN_NAMES;
                         }
@@ -594,10 +537,8 @@
                 case KDBUS_ITEM_CONN_NAME:
                         if ((mask & SD_BUS_CREDS_CONNECTION_NAME)) {
                                 c->conn_name = strdup(item->str);
-                                if (!c->conn_name) {
-                                        r = -ENOMEM;
-                                        goto fail;
-                                }
+                                if (!c->conn_name)
+                                        return -ENOMEM;
 
                                 c->mask |= SD_BUS_CREDS_CONNECTION_NAME;
                         }
@@ -605,6 +546,75 @@
                 }
         }
 
+        return 0;
+}
+
+static int bus_get_name_creds_kdbus(
+                sd_bus *bus,
+                const char *name,
+                uint64_t mask,
+                sd_bus_creds **creds) {
+
+        _cleanup_bus_creds_unref_ sd_bus_creds *c = NULL;
+        struct kdbus_cmd_info *cmd;
+        struct kdbus_info *conn_info;
+        size_t size, l;
+        uint64_t id;
+        int r;
+
+        r = bus_kernel_parse_unique_name(name, &id);
+        if (r < 0)
+                return r;
+        if (r > 0) {
+                size = offsetof(struct kdbus_cmd_info, items);
+                cmd = alloca0_align(size, 8);
+                cmd->id = id;
+        } else {
+                l = strlen(name) + 1;
+                size = offsetof(struct kdbus_cmd_info, items) + KDBUS_ITEM_SIZE(l);
+                cmd = alloca0_align(size, 8);
+                cmd->items[0].size = KDBUS_ITEM_HEADER_SIZE + l;
+                cmd->items[0].type = KDBUS_ITEM_NAME;
+                memcpy(cmd->items[0].str, name, l);
+        }
+
+        cmd->size = size;
+        kdbus_translate_attach_flags(mask, (uint64_t*) &cmd->flags);
+
+        r = ioctl(bus->input_fd, KDBUS_CMD_CONN_INFO, cmd);
+        if (r < 0)
+                return -errno;
+
+        conn_info = (struct kdbus_info *) ((uint8_t *) bus->kdbus_buffer + cmd->offset);
+
+        /* Non-activated names are considered not available */
+        if (conn_info->flags & KDBUS_HELLO_ACTIVATOR) {
+                if (name[0] == ':')
+                        r = -ENXIO;
+                else
+                        r = -ESRCH;
+                goto fail;
+        }
+
+        c = bus_creds_new();
+        if (!c) {
+                r = -ENOMEM;
+                goto fail;
+        }
+
+        if (mask & SD_BUS_CREDS_UNIQUE_NAME) {
+                if (asprintf(&c->unique_name, ":1.%llu", (unsigned long long) conn_info->id) < 0) {
+                        r = -ENOMEM;
+                        goto fail;
+                }
+
+                c->mask |= SD_BUS_CREDS_UNIQUE_NAME;
+        }
+
+        r = bus_populate_creds_from_items(bus, conn_info, mask, c);
+        if (r < 0)
+                goto fail;
+
         if (creds) {
                 *creds = c;
                 c = NULL;
@@ -617,7 +627,7 @@
         return r;
 }
 
-static int bus_get_owner_dbus1(
+static int bus_get_name_creds_dbus1(
                 sd_bus *bus,
                 const char *name,
                 uint64_t mask,
@@ -763,7 +773,7 @@
         return 0;
 }
 
-_public_ int sd_bus_get_owner(
+_public_ int sd_bus_get_name_creds(
                 sd_bus *bus,
                 const char *name,
                 uint64_t mask,
@@ -781,9 +791,72 @@
                 return -ENOTCONN;
 
         if (bus->is_kernel)
-                return bus_get_owner_kdbus(bus, name, mask, creds);
+                return bus_get_name_creds_kdbus(bus, name, mask, creds);
         else
-                return bus_get_owner_dbus1(bus, name, mask, creds);
+                return bus_get_name_creds_dbus1(bus, name, mask, creds);
+}
+
+_public_ int sd_bus_get_owner_creds(sd_bus *bus, uint64_t mask, sd_bus_creds **ret) {
+        _cleanup_bus_creds_unref_ sd_bus_creds *c = NULL;
+        pid_t pid = 0;
+        int r;
+
+        assert_return(bus, -EINVAL);
+        assert_return(mask <= _SD_BUS_CREDS_ALL, -ENOTSUP);
+        assert_return(ret, -EINVAL);
+        assert_return(!bus_pid_changed(bus), -ECHILD);
+
+        if (!BUS_IS_OPEN(bus->state))
+                return -ENOTCONN;
+
+        if (!bus->ucred_valid && !isempty(bus->label))
+                return -ENODATA;
+
+        c = bus_creds_new();
+        if (!c)
+                return -ENOMEM;
+
+        if (bus->ucred_valid) {
+                pid = c->pid = bus->ucred.pid;
+                c->uid = bus->ucred.uid;
+                c->gid = bus->ucred.gid;
+
+                c->mask |= (SD_BUS_CREDS_UID | SD_BUS_CREDS_PID | SD_BUS_CREDS_GID) & mask;
+        }
+
+        if (!isempty(bus->label) && (mask & SD_BUS_CREDS_SELINUX_CONTEXT)) {
+                c->label = strdup(bus->label);
+                if (!c->label)
+                        return -ENOMEM;
+
+                c->mask |= SD_BUS_CREDS_SELINUX_CONTEXT;
+        }
+
+        if (bus->is_kernel) {
+                struct kdbus_cmd_info cmd = {};
+                struct kdbus_info *creator_info;
+
+                cmd.size = sizeof(cmd);
+                r = ioctl(bus->input_fd, KDBUS_CMD_BUS_CREATOR_INFO, &cmd);
+                if (r < 0)
+                        return -errno;
+
+                creator_info = (struct kdbus_info *) ((uint8_t *) bus->kdbus_buffer + cmd.offset);
+
+                r = bus_populate_creds_from_items(bus, creator_info, mask, c);
+                kernel_cmd_free(bus, cmd.offset);
+
+                if (r < 0)
+                        return r;
+        } else {
+                r = bus_creds_add_more(c, mask, pid, 0);
+                if (r < 0)
+                        return r;
+        }
+
+        *ret = c;
+        c = NULL;
+        return 0;
 }
 
 static int add_name_change_match(sd_bus *bus,
@@ -1235,7 +1308,7 @@
                 return bus_remove_match_internal_dbus1(bus, match);
 }
 
-_public_ int sd_bus_get_owner_machine_id(sd_bus *bus, const char *name, sd_id128_t *machine) {
+_public_ int sd_bus_get_name_machine_id(sd_bus *bus, const char *name, sd_id128_t *machine) {
         _cleanup_bus_message_unref_ sd_bus_message *reply = NULL, *m = NULL;
         const char *mid;
         int r;
diff -urN systemd-216/src/libsystemd/sd-bus/bus-convenience.c systemd-217/src/libsystemd/sd-bus/bus-convenience.c
--- systemd-216/src/libsystemd/sd-bus/bus-convenience.c	2014-08-15 10:56:07.086645207 -0700
+++ systemd-217/src/libsystemd/sd-bus/bus-convenience.c	2014-10-22 11:30:06.646837633 -0700
@@ -465,9 +465,9 @@
                  * to get it from the sender or peer */
 
                 if (call->sender)
-                        return sd_bus_get_owner(call->bus, call->sender, mask, creds);
+                        return sd_bus_get_name_creds(call->bus, call->sender, mask, creds);
                 else
-                        return sd_bus_get_peer_creds(call->bus, mask, creds);
+                        return sd_bus_get_owner_creds(call->bus, mask, creds);
         }
 
         return bus_creds_extend_by_pid(c, mask, creds);
diff -urN systemd-216/src/libsystemd/sd-bus/busctl.c systemd-217/src/libsystemd/sd-bus/busctl.c
--- systemd-216/src/libsystemd/sd-bus/busctl.c	2014-11-03 09:35:27.865175864 -0800
+++ systemd-217/src/libsystemd/sd-bus/busctl.c	2014-10-22 11:30:06.646837633 -0700
@@ -142,7 +142,7 @@
 
                 printf("%-*s", (int) max_i, *i);
 
-                r = sd_bus_get_owner(bus, *i,
+                r = sd_bus_get_name_creds(bus, *i,
                                      SD_BUS_CREDS_UID|SD_BUS_CREDS_PID|SD_BUS_CREDS_COMM|
                                      SD_BUS_CREDS_UNIQUE_NAME|SD_BUS_CREDS_UNIT|SD_BUS_CREDS_SESSION|
                                      SD_BUS_CREDS_CONNECTION_NAME, &creds);
@@ -210,7 +210,7 @@
                         printf("          - -               -                -             -                         -          -                  ");
 
                 if (arg_show_machine) {
-                        r = sd_bus_get_owner_machine_id(bus, *i, &mid);
+                        r = sd_bus_get_name_machine_id(bus, *i, &mid);
                         if (r >= 0) {
                                 char m[SD_ID128_STRING_MAX];
                                 printf(" %s\n", sd_id128_to_string(mid, m));
@@ -306,7 +306,7 @@
 
         r = parse_pid(argv[1], &pid);
         if (r < 0)
-                r = sd_bus_get_owner(bus, argv[1], _SD_BUS_CREDS_ALL, &creds);
+                r = sd_bus_get_name_creds(bus, argv[1], _SD_BUS_CREDS_ALL, &creds);
         else
                 r = sd_bus_creds_new_from_pid(&creds, pid, _SD_BUS_CREDS_ALL);
 
diff -urN systemd-216/src/libsystemd/sd-bus/bus-error.c systemd-217/src/libsystemd/sd-bus/bus-error.c
--- systemd-216/src/libsystemd/sd-bus/bus-error.c	2014-11-03 09:35:35.669254553 -0800
+++ systemd-217/src/libsystemd/sd-bus/bus-error.c	2014-10-24 10:24:19.999505311 -0700
@@ -194,13 +194,10 @@
                 return -ENOMEM;
         }
 
-        if (format) {
-                int r;
-
-                r = vasprintf((char**) &e->message, format, ap);
-                if (r < 0)
-                        return -ENOMEM;
-        }
+        /* Of we hit OOM on formatting the pretty message, we ignore
+         * this, since we at least managed to write the error name */
+        if (format)
+                (void) vasprintf((char**) &e->message, format, ap);
 
         e->_need_free = 1;
 
diff -urN systemd-216/src/libsystemd/sd-bus/bus-error-mapping.gperf systemd-217/src/libsystemd/sd-bus/bus-error-mapping.gperf
--- systemd-216/src/libsystemd/sd-bus/bus-error-mapping.gperf	2014-01-21 12:42:49.228055640 -0800
+++ systemd-217/src/libsystemd/sd-bus/bus-error-mapping.gperf	2014-10-28 06:57:25.403036410 -0700
@@ -13,37 +13,38 @@
 %struct-type
 %includes
 %%
-org.freedesktop.DBus.Error.Failed,                        EACCES
-org.freedesktop.DBus.Error.NoMemory,                      ENOMEM
-org.freedesktop.DBus.Error.ServiceUnknown,                EHOSTUNREACH
-org.freedesktop.DBus.Error.NameHasNoOwner,                ENXIO
-org.freedesktop.DBus.Error.NoReply,                       ETIMEDOUT
-org.freedesktop.DBus.Error.IOError,                       EIO
-org.freedesktop.DBus.Error.BadAddress,                    EADDRNOTAVAIL
-org.freedesktop.DBus.Error.NotSupported,                  ENOTSUP
-org.freedesktop.DBus.Error.LimitsExceeded,                ENOBUFS
-org.freedesktop.DBus.Error.AccessDenied,                  EACCES
-org.freedesktop.DBus.Error.AuthFailed,                    EACCES
-org.freedesktop.DBus.Error.NoServer,                      EHOSTDOWN
-org.freedesktop.DBus.Error.Timeout,                       ETIMEDOUT
-org.freedesktop.DBus.Error.NoNetwork,                     ENONET
-org.freedesktop.DBus.Error.AddressInUse,                  EADDRINUSE
-org.freedesktop.DBus.Error.Disconnected,                  ECONNRESET
-org.freedesktop.DBus.Error.InvalidArgs,                   EINVAL
-org.freedesktop.DBus.Error.FileNotFound,                  ENOENT
-org.freedesktop.DBus.Error.FileExists,                    EEXIST
-org.freedesktop.DBus.Error.UnknownMethod,                 EBADR
-org.freedesktop.DBus.Error.UnknownObject,                 EBADR
-org.freedesktop.DBus.Error.UnknownInterface,              EBADR
-org.freedesktop.DBus.Error.UnknownProperty,               EBADR
-org.freedesktop.DBus.Error.PropertyReadOnly,              EROFS
-org.freedesktop.DBus.Error.UnixProcessIdUnknown,          ESRCH
-org.freedesktop.DBus.Error.InvalidSignature,              EINVAL
-org.freedesktop.DBus.Error.InconsistentMessage,           EBADMSG
+org.freedesktop.DBus.Error.Failed,                          EACCES
+org.freedesktop.DBus.Error.NoMemory,                        ENOMEM
+org.freedesktop.DBus.Error.ServiceUnknown,                  EHOSTUNREACH
+org.freedesktop.DBus.Error.NameHasNoOwner,                  ENXIO
+org.freedesktop.DBus.Error.NoReply,                         ETIMEDOUT
+org.freedesktop.DBus.Error.IOError,                         EIO
+org.freedesktop.DBus.Error.BadAddress,                      EADDRNOTAVAIL
+org.freedesktop.DBus.Error.NotSupported,                    ENOTSUP
+org.freedesktop.DBus.Error.LimitsExceeded,                  ENOBUFS
+org.freedesktop.DBus.Error.AccessDenied,                    EACCES
+org.freedesktop.DBus.Error.AuthFailed,                      EACCES
+org.freedesktop.DBus.Error.InteractiveAuthorizationRequired EACCES
+org.freedesktop.DBus.Error.NoServer,                        EHOSTDOWN
+org.freedesktop.DBus.Error.Timeout,                         ETIMEDOUT
+org.freedesktop.DBus.Error.NoNetwork,                       ENONET
+org.freedesktop.DBus.Error.AddressInUse,                    EADDRINUSE
+org.freedesktop.DBus.Error.Disconnected,                    ECONNRESET
+org.freedesktop.DBus.Error.InvalidArgs,                     EINVAL
+org.freedesktop.DBus.Error.FileNotFound,                    ENOENT
+org.freedesktop.DBus.Error.FileExists,                      EEXIST
+org.freedesktop.DBus.Error.UnknownMethod,                   EBADR
+org.freedesktop.DBus.Error.UnknownObject,                   EBADR
+org.freedesktop.DBus.Error.UnknownInterface,                EBADR
+org.freedesktop.DBus.Error.UnknownProperty,                 EBADR
+org.freedesktop.DBus.Error.PropertyReadOnly,                EROFS
+org.freedesktop.DBus.Error.UnixProcessIdUnknown,            ESRCH
+org.freedesktop.DBus.Error.InvalidSignature,                EINVAL
+org.freedesktop.DBus.Error.InconsistentMessage,             EBADMSG
 #
-org.freedesktop.DBus.Error.TimedOut,                      ETIMEDOUT
-org.freedesktop.DBus.Error.MatchRuleInvalid,              EINVAL
-org.freedesktop.DBus.Error.InvalidFileContent,            EINVAL
-org.freedesktop.DBus.Error.MatchRuleNotFound,             ENOENT
-org.freedesktop.DBus.Error.SELinuxSecurityContextUnknown, ESRCH
-org.freedesktop.DBus.Error.ObjectPathInUse,               EBUSY
+org.freedesktop.DBus.Error.TimedOut,                        ETIMEDOUT
+org.freedesktop.DBus.Error.MatchRuleInvalid,                EINVAL
+org.freedesktop.DBus.Error.InvalidFileContent,              EINVAL
+org.freedesktop.DBus.Error.MatchRuleNotFound,               ENOENT
+org.freedesktop.DBus.Error.SELinuxSecurityContextUnknown,   ESRCH
+org.freedesktop.DBus.Error.ObjectPathInUse,                 EBUSY
diff -urN systemd-216/src/libsystemd/sd-bus/bus-internal.h systemd-217/src/libsystemd/sd-bus/bus-internal.h
--- systemd-216/src/libsystemd/sd-bus/bus-internal.h	2014-08-18 12:01:57.391667772 -0700
+++ systemd-217/src/libsystemd/sd-bus/bus-internal.h	2014-10-23 10:00:37.304180671 -0700
@@ -230,7 +230,7 @@
 
         struct bus_match_node match_callbacks;
         Prioq *reply_callbacks_prioq;
-        Hashmap *reply_callbacks;
+        OrderedHashmap *reply_callbacks;
         LIST_HEAD(struct filter_callback, filter_callbacks);
 
         Hashmap *nodes;
diff -urN systemd-216/src/libsystemd/sd-bus/bus-kernel.c systemd-217/src/libsystemd/sd-bus/bus-kernel.c
--- systemd-216/src/libsystemd/sd-bus/bus-kernel.c	2014-11-03 09:35:36.126259161 -0800
+++ systemd-217/src/libsystemd/sd-bus/bus-kernel.c	2014-10-27 10:09:26.606862015 -0700
@@ -270,10 +270,15 @@
         m->kdbus->cookie = (uint64_t) m->header->serial;
         m->kdbus->priority = m->priority;
 
-        if (m->header->flags & BUS_MESSAGE_NO_REPLY_EXPECTED)
+        if (m->header->flags & BUS_MESSAGE_NO_REPLY_EXPECTED) {
                 m->kdbus->cookie_reply = m->reply_cookie;
-        else
-                m->kdbus->timeout_ns = m->timeout * NSEC_PER_USEC;
+        } else {
+                struct timespec now;
+
+                assert_se(clock_gettime(CLOCK_MONOTONIC_COARSE, &now) == 0);
+                m->kdbus->timeout_ns = now.tv_sec * NSEC_PER_SEC + now.tv_nsec +
+                                       m->timeout * NSEC_PER_USEC;
+        }
 
         d = m->kdbus->items;
 
@@ -570,8 +575,8 @@
                         break;
 
                 case KDBUS_ITEM_CAPS:
-                        m->creds.capability = d->data;
-                        m->creds.capability_size = l;
+                        m->creds.capability = (uint8_t *) d->caps.caps;
+                        m->creds.capability_size = d->size - offsetof(struct kdbus_item, caps.caps);
                         m->creds.mask |= (SD_BUS_CREDS_EFFECTIVE_CAPS|SD_BUS_CREDS_PERMITTED_CAPS|SD_BUS_CREDS_INHERITABLE_CAPS|SD_BUS_CREDS_BOUNDING_CAPS) & bus->creds_mask;
                         break;
 
@@ -714,7 +719,7 @@
 
         hello = alloca0_align(sz, 8);
         hello->size = sz;
-        hello->conn_flags = b->hello_flags;
+        hello->flags = b->hello_flags;
         hello->attach_flags = b->attach_flags;
         hello->pool_size = KDBUS_POOL_SIZE;
 
@@ -751,10 +756,9 @@
                 }
         }
 
-        /* The higher 32bit of both flags fields are considered
+        /* The higher 32bit of the bus_flags fields are considered
          * 'incompatible flags'. Refuse them all for now. */
-        if (hello->bus_flags > 0xFFFFFFFFULL ||
-            hello->conn_flags > 0xFFFFFFFFULL)
+        if (hello->bus_flags > 0xFFFFFFFFULL)
                 return -ENOTSUP;
 
         if (!bloom_validate_parameters((size_t) hello->bloom.size, (unsigned) hello->bloom.n_hash))
@@ -770,7 +774,7 @@
 
         b->is_kernel = true;
         b->bus_client = true;
-        b->can_fds = !!(hello->conn_flags & KDBUS_HELLO_ACCEPT_FD);
+        b->can_fds = !!(hello->flags & KDBUS_HELLO_ACCEPT_FD);
         b->message_version = 2;
         b->message_endian = BUS_NATIVE_ENDIAN;
 
@@ -1230,8 +1234,11 @@
         if (mask & (SD_BUS_CREDS_UID|SD_BUS_CREDS_GID|SD_BUS_CREDS_PID|SD_BUS_CREDS_PID_STARTTIME|SD_BUS_CREDS_TID))
                 m |= KDBUS_ATTACH_CREDS;
 
-        if (mask & (SD_BUS_CREDS_COMM|SD_BUS_CREDS_TID_COMM))
-                m |= KDBUS_ATTACH_COMM;
+        if (mask & SD_BUS_CREDS_COMM)
+                m |= KDBUS_ATTACH_PID_COMM;
+
+        if (mask & SD_BUS_CREDS_TID_COMM)
+                m |= KDBUS_ATTACH_TID_COMM;
 
         if (mask & SD_BUS_CREDS_EXE)
                 m |= KDBUS_ATTACH_EXE;
@@ -1307,13 +1314,6 @@
                 return -errno;
         }
 
-        /* The features field are considered 'incompatible flags'.
-         * Refuse them all for now. */
-        if (make->features) {
-                safe_close(fd);
-                return -ENOTSUP;
-        }
-
         if (s) {
                 char *p;
 
@@ -1444,13 +1444,6 @@
                 return -errno;
         }
 
-        /* The features field are considered 'incompatible flags'.
-         * Refuse them all for now. */
-        if (make->features) {
-                safe_close(fd);
-                return -ENOTSUP;
-        }
-
         if (ep_path) {
                 char *p;
 
@@ -1565,7 +1558,7 @@
         }
 
         hello->size = size;
-        hello->conn_flags =
+        hello->flags =
                 (activating ? KDBUS_HELLO_ACTIVATOR : KDBUS_HELLO_POLICY_HOLDER) |
                 (accept_fd ? KDBUS_HELLO_ACCEPT_FD : 0);
         hello->pool_size = KDBUS_POOL_SIZE;
@@ -1574,11 +1567,9 @@
         if (ioctl(fd, KDBUS_CMD_HELLO, hello) < 0)
                 return -errno;
 
-        /* The higher 32bit of both flags fields are considered
+        /* The higher 32bit of the bus_flags fields are considered
          * 'incompatible flags'. Refuse them all for now. */
-        if (hello->features ||
-            hello->bus_flags > 0xFFFFFFFFULL ||
-            hello->conn_flags > 0xFFFFFFFFULL)
+        if (hello->bus_flags > 0xFFFFFFFFULL)
                 return -ENOTSUP;
 
         if (!bloom_validate_parameters((size_t) hello->bloom.size, (unsigned) hello->bloom.n_hash))
diff -urN systemd-216/src/libsystemd/sd-bus/bus-match.c systemd-217/src/libsystemd/sd-bus/bus-match.c
--- systemd-216/src/libsystemd/sd-bus/bus-match.c	2014-11-03 09:35:27.863175844 -0800
+++ systemd-217/src/libsystemd/sd-bus/bus-match.c	2014-11-03 09:33:48.562174593 -0800
@@ -537,7 +537,7 @@
         else if (BUS_MATCH_CAN_HASH(t))
                 n = hashmap_get(c->compare.children, value_str);
         else {
-                for (n = c->child; !value_node_same(n, t, value_u8, value_str); n = n->next)
+                for (n = c->child; n && !value_node_same(n, t, value_u8, value_str); n = n->next)
                         ;
         }
 
diff -urN systemd-216/src/libsystemd/sd-bus/bus-message.c systemd-217/src/libsystemd/sd-bus/bus-message.c
--- systemd-216/src/libsystemd/sd-bus/bus-message.c	2014-11-03 09:35:35.640254261 -0800
+++ systemd-217/src/libsystemd/sd-bus/bus-message.c	2014-10-13 08:19:31.341674513 -0700
@@ -849,6 +849,13 @@
         return !(m->header->flags & BUS_MESSAGE_NO_AUTO_START);
 }
 
+_public_ int sd_bus_message_get_allow_interactive_authorization(sd_bus_message *m) {
+        assert_return(m, -EINVAL);
+
+        return m->header->type == SD_BUS_MESSAGE_METHOD_CALL &&
+                (m->header->flags & BUS_MESSAGE_ALLOW_INTERACTIVE_AUTHORIZATION);
+}
+
 _public_ const char *sd_bus_message_get_path(sd_bus_message *m) {
         assert_return(m, NULL);
 
@@ -998,6 +1005,18 @@
 
         return 0;
 }
+
+_public_ int sd_bus_message_set_allow_interactive_authorization(sd_bus_message *m, int b) {
+        assert_return(m, -EINVAL);
+        assert_return(!m->sealed, -EPERM);
+
+        if (b)
+                m->header->flags |= BUS_MESSAGE_ALLOW_INTERACTIVE_AUTHORIZATION;
+        else
+                m->header->flags &= ~BUS_MESSAGE_ALLOW_INTERACTIVE_AUTHORIZATION;
+
+        return 0;
+}
 
 static struct bus_container *message_get_container(sd_bus_message *m) {
         assert(m);
